\section{Mentoring}
Robert C. Martins does report that he often is disappointed by the qualities a CS graduate does bring.

\paragraph{Degrees of Failure}
He once interview a master candidate form the university that managed to not even go into one programming course. And typically CS graduates are not prepare to work in the software industry.

\subsection{Mentoring}
Mentoring is a very important aspect to evolve as a software developer. Martin does describe how he got mentored in his early years, this does include people as well as books and software manuals.

\paragraph{Unconventional Monitoring}
There are different types of mentoring as mentioned beforehand. Mentoring could also be just observing other people doing their work and copying their craftsmanship. The best mentor is another human, from which you can actively learn the stuff you want to learn.

\subsection{Apprenticeship}
In the medical area a doctor does spend nearly equal time in the university as well as in a hospital getting practical experience. 

In the software world this is rarely the case. Big companies often do throw fresh graduates into a team and let them create mission critical software.

\paragraph{Software Apprenticeship}
What are the steps you should follow in your career? Martin does propose three levels of software professionals. In reality these levels are often not really implemented.

\begin{itemize}
	\item Master - Work already for years in the field and are able to mentor other people.
	\item Journeymen - Are young programmers who are energetic, competent. But they lack experience. They get mentored by masters.
	\item Apprentices/Interns - Are fresh graduates which don't work alone on a project. They do everything in pair with a journeyman and after a year or so get to the level of the journeyman.
\end{itemize}

\subsection{Craftsmanship}
Now we can define what craftsmanship is. 

\begin{quote}
	Craftsmanship is the mindset held by craftsmen. Craftsmanship is a meme that contains values, principles, techniques, attitudes and answers.  - Robert C. Martin
\end{quote}

Craftsmanship is not learned in school, it's taught by mentors on the job.